Index: libCERTI/FedTime.cc
===================================================================
RCS file: /sources/certi/certi/libCERTI/FedTime.cc,v
retrieving revision 3.15
diff -u -r3.15 FedTime.cc
--- libCERTI/FedTime.cc	10 Dec 2008 16:53:24 -0000	3.15
+++ libCERTI/FedTime.cc	2 Apr 2009 19:56:32 -0000
@@ -17,241 +17,101 @@
 // You should have received a copy of the GNU Lesser General Public
 // License along with this program ; if not, write to the Free Software
 // Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
+//
+// $Id: FedTime.cc,v 3.15.4.2 2009/01/05 15:22:34 gotthardp Exp $
 // ----------------------------------------------------------------------------
 
 #include <math.h>
 
-#include "certi.hh"
-#include "fedtime.hh"
-#include "HLAtypesIEEE1516.hh"
-
-#ifdef _WIN32
-	#ifdef max
-		#undef max
-	#endif
-#endif
+#include "FedTimeD.hh"
 
-#include <algorithm>
 #include <limits>
 #include <sstream>
-#include <typeinfo>
 
-using std::stringstream ;
-
-typedef RTI::FedTime FedTime ;
-typedef RTI::Double Double ;
+using namespace certi;
 
 namespace
 {
 
-// ----------------------------------------------------------------------------
-/** FedTime to RTIfedTime reference cast
- */
-inline const RTIfedTime &
-rft(const FedTime &time)
-    throw (RTI::InvalidFederationTime)
-{
-    try {
-	return dynamic_cast<const RTIfedTime &>(time);
-    }
-    catch (std::bad_cast) {
-	throw RTI::InvalidFederationTime("Could not cast to RTIfedTime");
-    }
-}
-
-inline bool
-is_infinity(const FedTime &time)
-{
-    return const_cast<FedTime &>(time).isPositiveInfinity() == RTI::RTI_TRUE ;
-}
-
-/*
- fcmp
- Copyright (c) 1998-2000 Theodore C. Belding
- University of Michigan Center for the Study of Complex Systems
- <mailto:Ted.Belding@umich.edu>
- <http://fcmp.sourceforge.net>
-
- This file is part of the fcmp distribution. fcmp is free software;
- you can redistribute and modify it under the terms of the GNU Library
- General Public License (LGPL), version 2 or later.  This software
- comes with absolutely no warranty. See the file COPYING for details
- and terms of copying.
-
- Description:
-
- Knuth's floating point comparison operators, from:
- Knuth, D. E. (1998). The Art of Computer Programming.
- Volume 2: Seminumerical Algorithms. 3rd ed. Addison-Wesley.
- Section 4.2.2, p. 233. ISBN 0-201-89684-2.
-
- Input parameters:
- x1, x2: numbers to be compared
- epsilon: determines tolerance
-
- epsilon should be carefully chosen based on the machine's precision,
- the observed magnitude of error, the desired precision, and the
- magnitude of the numbers to be compared. See the fcmp README file for
- more information.
-
- This routine may be used for both single-precision (float) and
- double-precision (double) floating-point numbers.
-
- Returns:
- -1 if x1 < x2
-  0 if x1 == x2
-  1 if x1 > x2
-*/
-
-inline int
-fcmp(double x1,double x2, double epsilon)
-{
-    int exponent;
-    double delta;
-    double difference;
-
-    /* Get exponent(max(fabs(x1), fabs(x2))) and store it in exponent. */
-
-    /* If neither x1 nor x2 is 0, */
-    /* this is equivalent to max(exponent(x1), exponent(x2)). */
-
-    /* If either x1 or x2 is 0, its exponent returned by frexp would be 0, */
-    /* which is much larger than the exponents of numbers close to 0 in */
-    /* magnitude. But the exponent of 0 should be less than any number */
-    /* whose magnitude is greater than 0. */
-
-    /* So we only want to set exponent to 0 if both x1 and */
-    /* x2 are 0. Hence, the following works for all x1 and x2. */
-
-    frexp(fabs(x1) > fabs(x2) ? x1 : x2, &exponent);
-
-    /* Do the comparison. */
-
-    /* delta = epsilon * pow(2, exponent) */
-
-    /* Form a neighborhood around x2 of size delta in either direction. */
-    /* If x1 is within this delta neighborhood of x2, x1 == x2. */
-    /* Otherwise x1 > x2 or x1 < x2, depending on which side of */
-    /* the neighborhood x1 is on. */
-
-    delta = ldexp(epsilon, exponent);
-
-    difference = x1 - x2;
-
-    if (difference > delta)
-        return 1; /* x1 > x2 */
-    else if (difference < -delta)
-        return -1;  /* x1 < x2 */
-    else /* -delta <= difference <= delta */
-        return 0;  /* x1 == x2 */
-}
-
 const char *infinity_str = "+inf" ;
 
 } // anonymous namespace
 
 // ----------------------------------------------------------------------------
-// FedTimeFactory
-RTI::FedTime *
-RTI::FedTimeFactory::makeZero()
-    throw (RTI::MemoryExhausted)
-{
-    return new RTIfedTime();
-}
-
-RTI::FedTime *
-RTI::FedTimeFactory::decode(const char *)
-    throw (RTI::MemoryExhausted)
-{
-    throw RTI::RTIinternalError("Not implemented");
-}
-
-// ----------------------------------------------------------------------------
 // FedTime
-//FedTime::~FedTime()
-//{
-//}
 
-const double RTIfedTime::epsilon = std::numeric_limits<double>::epsilon();
+const double FedTime::epsilon = std::numeric_limits<double>::epsilon();
 
 int
-RTIfedTime::fcmp(const double x1, const double x2) {
-	return ::fcmp(x1,x2,RTIfedTime::epsilon);
+FedTime::fcmp(const double x1, const double x2) {
+	return certi::fcmp(x1,x2,FedTime::epsilon);
 }
 
 // ----------------------------------------------------------------------------
-// RTIfedTime
-RTIfedTime::RTIfedTime()
+// FedTime
+FedTime::FedTime()
     : _fedTime(0),
       _zero(0),
-      _epsilon(RTIfedTime::epsilon),
+      _epsilon(FedTime::epsilon),
       _positiveInfinity(std::numeric_limits<double>::infinity()) { }
 
-RTIfedTime::RTIfedTime(const RTI::Double &time)
+FedTime::FedTime(const double &time)
     : _fedTime(time),
       _zero(0),
-      _epsilon(RTIfedTime::epsilon),
-      _positiveInfinity(std::numeric_limits<double>::infinity()) { }
-
-RTIfedTime::RTIfedTime(const FedTime &time)
-    : _fedTime(rft(time).getTime()),
-      _zero(0),
-      _epsilon(RTIfedTime::epsilon),
+      _epsilon(FedTime::epsilon),
       _positiveInfinity(std::numeric_limits<double>::infinity()) { }
 
-// ----------------------------------------------------------------------------
-RTIfedTime::RTIfedTime(const RTIfedTime &time)
-    : FedTime(),
-      _fedTime(time._fedTime),
+FedTime::FedTime(const FedTime &time)
+    : _fedTime(time._fedTime),
       _zero(time._zero),
       _epsilon(time._epsilon),
       _positiveInfinity(time._positiveInfinity) { }
 
 // ----------------------------------------------------------------------------
-RTIfedTime::~RTIfedTime()
+FedTime::~FedTime()
 {
 }
 
 // ----------------------------------------------------------------------------
 void
-RTIfedTime::setZero()
+FedTime::setZero()
 {
     _fedTime = _zero;
 }
 
 // ----------------------------------------------------------------------------
-RTI::Boolean
-RTIfedTime::isZero()
+bool
+FedTime::isZero()
 {
-    return RTI::Boolean(_fedTime == _zero);
+    return bool(_fedTime == _zero);
 }
 
 // ----------------------------------------------------------------------------
 void
-RTIfedTime::setEpsilon()
+FedTime::setEpsilon()
 {
     _fedTime = _epsilon;
 }
 
 // ----------------------------------------------------------------------------
 void
-RTIfedTime::setPositiveInfinity()
+FedTime::setPositiveInfinity()
 {
     _fedTime = _positiveInfinity;
 }
 
 // ----------------------------------------------------------------------------
-inline RTI::Boolean
-RTIfedTime::isPositiveInfinity()
+bool
+FedTime::isPositiveInfinity() const
 {
-    return RTI::Boolean(_fedTime == _positiveInfinity);
+    return bool(_fedTime == _positiveInfinity);
 }
 
 // ----------------------------------------------------------------------------
 int
-RTIfedTime::encodedLength() const
+FedTime::encodedLength() const
 {
-	// current implementation of RTIfedtime takes
+	// current implementation of FedTime takes
 	// four IEEE-754 double values.
 	return (sizeof(_fedTime)+
 			sizeof(_zero)+
@@ -261,20 +121,20 @@
 
 // ----------------------------------------------------------------------------
 void
-RTIfedTime::encode(char *buffer) const
+FedTime::encode(char *buffer) const
 {
-	libhla::HLAfloat64LE encoded_fedTime;
-	encoded_fedTime = _fedTime;
-	strncpy(buffer,(char*)&(encoded_fedTime),encoded_fedTime.__sizeof());
+//	libhla::HLAfloat64LE encoded_fedTime;
+//	encoded_fedTime = _fedTime;
+//	strncpy(buffer,(char*)&(encoded_fedTime),encoded_fedTime.__sizeof());
 }
 
 // ----------------------------------------------------------------------------
 int
-RTIfedTime::getPrintableLength() const
+FedTime::getPrintableLength() const
 {
-    stringstream s ;
+    std::stringstream s ;
 
-    if (is_infinity(*this))
+    if (isPositiveInfinity())
 	s << infinity_str ;
     else
 	s << _fedTime ;
@@ -284,11 +144,11 @@
 
 // ----------------------------------------------------------------------------
 void
-RTIfedTime::getPrintableString(char *str)
+FedTime::getPrintableString(char *str)
 {
-    stringstream s ;
+    std::stringstream s ;
 
-    if (is_infinity(*this))
+    if (isPositiveInfinity())
 	s << infinity_str ;
     else
 	s << _fedTime ;
@@ -299,127 +159,107 @@
 
 // ----------------------------------------------------------------------------
 FedTime &
-RTIfedTime::operator+=(const FedTime &time)
-    throw (RTI::InvalidFederationTime)
+FedTime::operator+=(const FedTime &time)
 {
-    _fedTime += rft(time)._fedTime ;
+    _fedTime += time._fedTime ;
     return *this;
 }
 
 // ----------------------------------------------------------------------------
 FedTime &
-RTIfedTime::operator-=(const FedTime &time)
-    throw (RTI::InvalidFederationTime)
+FedTime::operator-=(const FedTime &time)
 {
-    _fedTime -= rft(time)._fedTime ;
+    _fedTime -= time._fedTime ;
     return *this;
 }
 
 // ----------------------------------------------------------------------------
-RTI::Boolean
-RTIfedTime::operator<=(const FedTime &time) const
-    throw (RTI::InvalidFederationTime)
+bool
+FedTime::operator<=(const FedTime &time) const
 {
     if (const_cast<FedTime &>(time).isPositiveInfinity())
-	return RTI::RTI_TRUE ;
-    else if (is_infinity(*this))
-	return RTI::RTI_FALSE ;
+	return true;
+    else if (isPositiveInfinity())
+	return false;
     else
-	return RTI::Boolean(::fcmp(_fedTime, rft(time)._fedTime, _epsilon) <= 0);
+	return bool(::fcmp(_fedTime, time._fedTime, _epsilon) <= 0);
 }
 
 // ----------------------------------------------------------------------------
-RTI::Boolean
-RTIfedTime::operator<(const FedTime &time) const
-    throw (RTI::InvalidFederationTime)
+bool
+FedTime::operator<(const FedTime &time) const
 {
-    if (is_infinity(*this))
-	return RTI::RTI_FALSE ;
+    if (isPositiveInfinity())
+	return false;
     else
-	return RTI::Boolean(is_infinity(time) || ::fcmp(_fedTime, rft(time)._fedTime, _epsilon) < 0);
+	return bool(time.isPositiveInfinity() || ::fcmp(_fedTime, time._fedTime, _epsilon) < 0);
 }
 
 // ----------------------------------------------------------------------------
-RTI::Boolean
-RTIfedTime::operator>=(const FedTime &time) const
-    throw (RTI::InvalidFederationTime)
+bool
+FedTime::operator>=(const FedTime &time) const
 {
-    if (is_infinity(*this))
-	return RTI::RTI_TRUE ;
-    else if (is_infinity(time))
-	return RTI::RTI_FALSE ;
+    if (isPositiveInfinity())
+	return true;
+    else if (time.isPositiveInfinity())
+	return false;
     else
-	return RTI::Boolean(::fcmp(_fedTime, rft(time)._fedTime, _epsilon) >= 0);
+	return bool(::fcmp(_fedTime, time._fedTime, _epsilon) >= 0);
 }
 
 // ----------------------------------------------------------------------------
-RTI::Boolean
-RTIfedTime::operator>(const FedTime &time) const
-    throw (RTI::InvalidFederationTime)
+bool
+FedTime::operator>(const FedTime &time) const
 {
-    if (is_infinity(time))
-	return RTI::RTI_FALSE ;
+    if (time.isPositiveInfinity())
+	return false;
     else
-	return RTI::Boolean(is_infinity(*this) || ::fcmp(_fedTime, rft(time)._fedTime, _epsilon) > 0);
+	return bool(isPositiveInfinity() || ::fcmp(_fedTime, time._fedTime, _epsilon) > 0);
 }
 
 // ----------------------------------------------------------------------------
-inline RTI::Boolean
-RTIfedTime::operator==(const FedTime &time) const
-    throw (RTI::InvalidFederationTime)
+bool
+FedTime::operator==(const FedTime &time) const
 {
-    if (is_infinity(*this) && is_infinity(time))
-	return RTI::RTI_TRUE ;
-    else if (is_infinity(*this) || is_infinity(time))
-	return RTI::RTI_FALSE ;
+    if (isPositiveInfinity() && time.isPositiveInfinity())
+	return true;
+    else if (isPositiveInfinity() || time.isPositiveInfinity())
+	return false;
     else
-	return RTI::Boolean(::fcmp(_fedTime, rft(time)._fedTime, _epsilon) == 0);
+	return bool(::fcmp(_fedTime, time._fedTime, _epsilon) == 0);
 }
 
 // ----------------------------------------------------------------------------
-FedTime &
-RTIfedTime::operator=(const FedTime &time)
-    throw (RTI::InvalidFederationTime)
-{
-    _fedTime = rft(time)._fedTime ;
-    return *this ;
-}
-
-// ----------------------------------------------------------------------------
-RTI::Double
-RTIfedTime::getTime() const
+double
+FedTime::getTime() const
 {
     return _fedTime ;
 }
 
 // ----------------------------------------------------------------------------
-RTI::Boolean
-RTIfedTime::operator==(const Double &time) const
-    throw (RTI::InvalidFederationTime)
+bool
+FedTime::operator==(const double &time) const
 {
-    return RTI::Boolean(!is_infinity(*this) && ::fcmp(_fedTime, time, _epsilon) == 0);
+    return bool(!isPositiveInfinity() && ::fcmp(_fedTime, time, _epsilon) == 0);
 }
 
 // ----------------------------------------------------------------------------
-RTI::Boolean
-RTIfedTime::operator!=(const FedTime &time) const
-    throw (RTI::InvalidFederationTime)
+bool
+FedTime::operator!=(const FedTime &time) const
 {
-    return RTI::Boolean(::fcmp(_fedTime, rft(time)._fedTime, _epsilon) != 0);
+    return bool(::fcmp(_fedTime, time._fedTime, _epsilon) != 0);
 }
 
 // ----------------------------------------------------------------------------
-RTI::Boolean
-RTIfedTime::operator!=(const Double &time) const
-    throw (RTI::InvalidFederationTime)
+bool
+FedTime::operator!=(const double &time) const
 {
-    return RTI::Boolean(is_infinity(*this) || ::fcmp(_fedTime, time, _epsilon) != 0);
+    return bool(isPositiveInfinity() || ::fcmp(_fedTime, time, _epsilon) != 0);
 }
 
 // ----------------------------------------------------------------------------
 FedTime &
-RTIfedTime::operator=(const RTIfedTime &time)
-    throw (RTI::InvalidFederationTime)
+FedTime::operator=(const FedTime &time)
 {
     _fedTime = time._fedTime ;
     return *this ;
@@ -427,170 +267,159 @@
 
 // ----------------------------------------------------------------------------
 FedTime &
-RTIfedTime::operator=(const Double &time)
-    throw (RTI::InvalidFederationTime)
+FedTime::operator=(const double &time)
 {
     _fedTime = time ;
     return *this ;
 }
 
 FedTime &
-RTIfedTime::operator*=(const RTI::FedTime &time)
-    throw (RTI::InvalidFederationTime)
+FedTime::operator*=(const FedTime &time)
 {
-    _fedTime *= rft(time)._fedTime ;
+    _fedTime *= time._fedTime ;
     return *this ;
 }
 
 FedTime &
-RTIfedTime::operator/=(const RTI::FedTime &time)
-    throw (RTI::InvalidFederationTime)
+FedTime::operator/=(const FedTime &time)
 {
-    _fedTime /= rft(time)._fedTime ;
+    _fedTime /= time._fedTime ;
     return *this ;
 }
 
 FedTime &
-RTIfedTime::operator+=(const RTI::Double &time)
-    throw (RTI::InvalidFederationTime)
+FedTime::operator+=(const double &time)
 {
     _fedTime += time ;
     return *this ;
 }
 
 FedTime &
-RTIfedTime::operator-=(const RTI::Double &time)
-    throw (RTI::InvalidFederationTime)
+FedTime::operator-=(const double &time)
 {
     _fedTime -= time ;
     return *this ;
 }
 
 FedTime &
-RTIfedTime::operator*=(const RTI::Double &time)
-    throw (RTI::InvalidFederationTime)
+FedTime::operator*=(const double &time)
 {
     _fedTime *= time ;
     return *this ;
 }
 
 FedTime &
-RTIfedTime::operator/=(const RTI::Double &time)
-    throw (RTI::InvalidFederationTime)
+FedTime::operator/=(const double &time)
 {
     _fedTime /= time ;
     return *this ;
 }
 
 // ----------------------------------------------------------------------------
-RTIfedTime
-RTIfedTime::operator+(const FedTime &time)
-    throw (RTI::InvalidFederationTime)
+FedTime
+FedTime::operator+(const FedTime &time)
 {
-    RTIfedTime fedtime = _fedTime + rft(time)._fedTime ;
+    FedTime fedtime = _fedTime + time._fedTime ;
     return fedtime ;
 }
 
-RTIfedTime
-RTIfedTime::operator+(const Double &time)
-    throw (RTI::InvalidFederationTime)
+FedTime
+FedTime::operator+(const double &time)
 {
-    RTIfedTime fedtime = _fedTime + time ;
+    FedTime fedtime = _fedTime + time ;
     return fedtime ;
 }
 
 // ----------------------------------------------------------------------------
-RTIfedTime
-RTIfedTime::operator-(const FedTime &time)
-    throw (RTI::InvalidFederationTime)
+FedTime
+FedTime::operator-(const FedTime &time)
 {
-    RTIfedTime fedtime = _fedTime - rft(time)._fedTime ;
+    FedTime fedtime = _fedTime - time._fedTime ;
     return fedtime ;
 }
 
-RTIfedTime
-RTIfedTime::operator-(const Double &time)
-    throw (RTI::InvalidFederationTime)
+FedTime
+FedTime::operator-(const double &time)
 {
-    RTIfedTime fedtime = _fedTime - time ;
+    FedTime fedtime = _fedTime - time ;
     return fedtime ;
 }
 
 // ----------------------------------------------------------------------------
-RTIfedTime
-RTIfedTime::operator*(const FedTime &time)
-    throw (RTI::InvalidFederationTime)
+FedTime
+FedTime::operator*(const FedTime &time)
 {
-    RTIfedTime fedtime = _fedTime * rft(time)._fedTime ;
+    FedTime fedtime = _fedTime * time._fedTime ;
     return fedtime ;
 }
 
-RTIfedTime
-RTIfedTime::operator*(const Double &time)
-    throw (RTI::InvalidFederationTime)
+FedTime
+FedTime::operator*(const double &time)
 {
-    RTIfedTime fedtime = _fedTime * time ;
+    FedTime fedtime = _fedTime * time ;
     return fedtime ;
 }
 
 // ----------------------------------------------------------------------------
-RTIfedTime
-RTIfedTime::operator/(const FedTime &time)
-    throw (RTI::InvalidFederationTime)
+FedTime
+FedTime::operator/(const FedTime &time)
 {
-    RTIfedTime fedtime = _fedTime / rft(time)._fedTime ;
+    FedTime fedtime = _fedTime / time._fedTime ;
     return fedtime ;
 }
 
-RTIfedTime
-RTIfedTime::operator/(const Double &time)
-    throw (RTI::InvalidFederationTime)
+FedTime
+FedTime::operator/(const double &time)
 {
-    RTIfedTime fedtime = _fedTime / time ;
+    FedTime fedtime = _fedTime / time ;
     return fedtime ;
 }
 
 // ----------------------------------------------------------------------------
+namespace certi {
 std::ostream &
 operator<<(std::ostream &s, const FedTime &time)
 {
-    if (is_infinity(time))
+    if (time.isPositiveInfinity())
 	s << infinity_str ;
     else
-	s << rft(time).getTime();
+	s << time.getTime();
     return s ;
 }
-
+}
 // ============================================================================
 
 // ----------------------------------------------------------------------------
-RTIfedTime
-operator+(const Double &d, const FedTime &time)
+FedTime
+operator+(const double &d, const FedTime &time)
 {
-    RTIfedTime fedtime = d + rft(time).getTime();
+    FedTime fedtime = d + time.getTime();
     return fedtime ;
 }
 
 // ----------------------------------------------------------------------------
-RTIfedTime
-operator-(const Double &d, const FedTime &time)
+FedTime
+operator-(const double &d, const FedTime &time)
 {
-    RTIfedTime fedtime = d - rft(time).getTime();
+    FedTime fedtime = d - time.getTime();
     return fedtime ;
 }
 
 // ----------------------------------------------------------------------------
-RTIfedTime
-operator*(const Double &d, const FedTime &time)
+FedTime
+operator*(const double &d, const FedTime &time)
 {
-    RTIfedTime fedtime = d * rft(time).getTime();
+    FedTime fedtime = d * time.getTime();
     return fedtime ;
 }
 
 // ----------------------------------------------------------------------------
-RTIfedTime
-operator/(const Double &d, const FedTime &time)
+FedTime
+operator/(const double &d, const FedTime &time)
 {
-    RTIfedTime fedtime = d / rft(time).getTime();
+    FedTime fedtime = d / time.getTime();
     return fedtime ;
 }
+
+// $Id: FedTime.cc,v 3.15.4.2 2009/01/05 15:22:34 gotthardp Exp $
+
Index: libCERTI/SocketMC.cc
===================================================================
RCS file: /sources/certi/certi/libCERTI/SocketMC.cc,v
retrieving revision 3.16
diff -u -r3.16 SocketMC.cc
--- libCERTI/SocketMC.cc	2 Nov 2008 12:54:40 -0000	3.16
+++ libCERTI/SocketMC.cc	2 Apr 2009 19:56:32 -0000
@@ -32,6 +32,7 @@
 #endif
 #include <cassert>
 #include <cstdlib>
+#include <cstring>
 
 namespace certi {
 
Index: libCERTI/NetworkMessage_RW.cc
===================================================================
RCS file: /sources/certi/certi/libCERTI/NetworkMessage_RW.cc,v
retrieving revision 3.52
diff -u -r3.52 NetworkMessage_RW.cc
--- libCERTI/NetworkMessage_RW.cc	23 Oct 2008 13:46:19 -0000	3.52
+++ libCERTI/NetworkMessage_RW.cc	2 Apr 2009 19:56:32 -0000
@@ -16,8 +16,9 @@
 // License along with this program ; if not, write to the Free Software
 // Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 //
-// $Id: NetworkMessage_RW.cc,v 3.52 2008/10/23 13:46:19 erk Exp $
+// $Id: NetworkMessage_RW.cc,v 3.52.4.1 2009/01/05 13:34:52 gotthardp Exp $
 // ----------------------------------------------------------------------------
+
 #include "NetworkMessage.hh"
 #include "PrettyDebug.hh"
 
@@ -53,8 +54,8 @@
 	 */
 	msgBuffer.write_bool(_isDated);
 	if (_isDated) {
-		msgBuffer.write_double(date);
-		D.Out(pdDebug, "Sent Message date is  <%f>", date);
+		msgBuffer.write_double(date.getTime());
+		D.Out(pdDebug, "Sent Message date is  <%f>", date.getTime());
 	}
 	msgBuffer.write_bool(_isLabelled);
 	if (_isLabelled) {
@@ -74,8 +75,8 @@
 	 */
 	D[pdDebug] << "Deserialize <" << getName().c_str()<<">"<<endl;
 	/* deserialize common part */
-	type        = static_cast<certi::NetworkMessage::Type>(msgBuffer.read_int32());
-	exception   = static_cast<certi::TypeException>(msgBuffer.read_int32());
+	type        = static_cast<NetworkMessage::Type>(msgBuffer.read_int32());
+	exception   = static_cast<TypeException>(msgBuffer.read_int32());
 	federate    = msgBuffer.read_int32();
 	federation  = msgBuffer.read_int32();
 	/*
@@ -87,7 +88,7 @@
 	_isDated = msgBuffer.read_bool();
 	if (_isDated) {
 		date = msgBuffer.read_double();
-		D.Out(pdDebug, "Received Message date is  <%f>", date);
+		D.Out(pdDebug, "Received Message date is  <%f>", date.getTime());
 	}
 	_isLabelled = msgBuffer.read_bool();
 	if (_isLabelled) {
@@ -151,4 +152,4 @@
 
 } // namespace certi
 
-// $Id: NetworkMessage_RW.cc,v 3.52 2008/10/23 13:46:19 erk Exp $
+// $Id: NetworkMessage_RW.cc,v 3.52.4.1 2009/01/05 13:34:52 gotthardp Exp $
Index: RTIG/Federation.cc
===================================================================
RCS file: /sources/certi/certi/RTIG/Federation.cc,v
retrieving revision 3.103
diff -u -r3.103 Federation.cc
--- RTIG/Federation.cc	16 Dec 2008 07:08:29 -0000	3.103
+++ RTIG/Federation.cc	2 Apr 2009 19:56:31 -0000
@@ -712,7 +712,7 @@
     federate.setRegulator(true);
 
     D.Out(pdTerm, "Federation %d: Federate %d is now a regulator(Time=%f).",
-          handle, federate_handle, time);
+          handle, federate_handle, time.getTime());
 
     NM_Set_Time_Regulating msg ;
     msg.exception = e_NO_EXCEPTION ;
@@ -1909,7 +1909,7 @@
     }
 
     D.Out(pdTerm, "Federation %d: Federate %d's new time is %f.",
-          handle, federate_handle, time);
+          handle, federate_handle, time.getTime());
 
     regulators.update(federate_handle, time);
 
Index: RTIG/RTIG.cc
===================================================================
RCS file: /sources/certi/certi/RTIG/RTIG.cc,v
retrieving revision 3.54
diff -u -r3.54 RTIG.cc
--- RTIG/RTIG.cc	7 Dec 2008 20:16:11 -0000	3.54
+++ RTIG/RTIG.cc	2 Apr 2009 19:56:31 -0000
@@ -205,7 +205,7 @@
 
       case NetworkMessage::SET_TIME_REGULATING:
         D.Out(pdTrace, "SetTimeRegulating du federe %u(date=%f).",
-              msg->federate, msg->getDate());
+              msg->federate, msg->getDate().getTime());
         auditServer.setLevel(8);
         processSetTimeRegulating(link, static_cast<NM_Set_Time_Regulating*>(msg));
         break ;
Index: RTIG/RTIG_processing.cc
===================================================================
RCS file: /sources/certi/certi/RTIG/RTIG_processing.cc,v
retrieving revision 3.80
diff -u -r3.80 RTIG_processing.cc
--- RTIG/RTIG_processing.cc	7 Dec 2008 20:16:11 -0000	3.80
+++ RTIG/RTIG_processing.cc	2 Apr 2009 19:56:32 -0000
@@ -520,7 +520,7 @@
   G.Out(pdGendoc,"BEGIN ** SET TIME REGULATING **");
 
   if (msg->isRegulator()) {
-        auditServer << "ON at time " << msg->getDate();
+        auditServer << "ON at time " << msg->getDate().getTime();
 
         federations.createRegulator(msg->federation,
                                      msg->federate,
@@ -561,7 +561,7 @@
   G.Out(pdGendoc,"BEGIN ** SET TIME CONSTRAINED **");
 
   if (msg->isConstrained()) {
-        auditServer << "ON at time " << msg->getDate();
+        auditServer << "ON at time " << msg->getDate().getTime();
 
         federations.addConstrained(msg->federation,
                                     msg->federate);
@@ -597,7 +597,7 @@
 void
 RTIG::processMessageNull(NetworkMessage *msg)
 {
-    auditServer << "Date " << msg->getDate() ;
+    auditServer << "Date " << msg->getDate().getTime();
 
     // Catch all exceptions because RTIA does not expect an answer anyway.
     try {
@@ -919,7 +919,7 @@
     std::vector <AttributeValue_t> ValueArray ;
 
     auditServer << "ObjID = " << req->object
-		<< ", Date = " << req->getDate() ;
+		<< ", Date = " << req->getDate().getTime();
 
     // Get Value Array
     ValueArray = req->getAttribValueArray();
@@ -976,7 +976,7 @@
 
     // Building Value Array
     auditServer << "IntID = " << req->interactionClass
-		<< ", date = " << req->getDate() ;
+		<< ", date = " << req->getDate().getTime();
     values = req->getParamValueArray();
 
     if ( req->isDated() )
Index: libRTI/CMakeLists.txt
===================================================================
RCS file: /sources/certi/certi/libRTI/CMakeLists.txt,v
retrieving revision 1.10
diff -u -r1.10 CMakeLists.txt
--- libRTI/CMakeLists.txt	7 Dec 2008 20:16:16 -0000	1.10
+++ libRTI/CMakeLists.txt	2 Apr 2009 19:56:32 -0000
@@ -4,8 +4,10 @@
 SET(RTI_LIB_SRCS
   RTIambassador.cc
   RTIambPrivateRefs.cc
+  RTIambPrivateRefs.hh
   RTItypes.cc
   RTItypesImp.cc
+  RTItypesImp.hh
   )
   
 SET(RTI_LIB_INCLUDE
@@ -21,7 +23,7 @@
 #SOURCE_GROUP("RTI\\Header" FILES ${RTI_LIB_INCLUDE})
 
 ADD_LIBRARY(RTI ${RTI_LIB_SRCS} ${RTI_LIB_INCLUDE})
-TARGET_LINK_LIBRARIES(RTI CERTI)
+TARGET_LINK_LIBRARIES(RTI CERTI FedTime)
 
 SET_TARGET_PROPERTIES(RTI PROPERTIES OUTPUT_NAME "RTI-NG")
 SET_TARGET_PROPERTIES(RTI PROPERTIES VERSION 1.0.0 SOVERSION 1)
@@ -31,7 +33,44 @@
             DESTINATION lib)
 ENDIF (MINGW)
 
-INSTALL(TARGETS RTI
+##################################################################
+# Lib FedTime 
+# A replacement lib FedTime may be provided by the user
+# CERTI is provided one. The lib FedTime depends on libRTI
+# since it inherits from the RTI::FedTime abstract class.
+##################################################################
+IF(CMAKE_COMPILER_IS_GNUCC)
+    SET(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wno-long-long")
+ENDIF(CMAKE_COMPILER_IS_GNUCC)
+IF(CMAKE_COMPILER_IS_GNUCXX)
+    SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-long-long")
+ENDIF(CMAKE_COMPILER_IS_GNUCXX)
+
+INCLUDE_DIRECTORIES(../libHLA)
+SET(FEDTIME_SRCS
+    RTIfedTime.cc
+    ${CMAKE_SOURCE_DIR}/include/fedtime.hh
+)
+
+SOURCE_GROUP("Source Files\\FedTime" FILES ${FEDTIME_SRCS})
+
+ADD_LIBRARY(FedTime
+    ${FEDTIME_SRCS}
+)
+
+TARGET_LINK_LIBRARIES(FedTime)
+
+SET_TARGET_PROPERTIES(FedTime PROPERTIES PROJECT_LABEL LibFedTime)
+IF (MINGW)
+    SET_TARGET_PROPERTIES(FedTime PROPERTIES LINK_FLAGS "-Wl,--output-def,${LIBRARY_OUTPUT_PATH}/libFedTime.def")
+    INSTALL(FILES ${LIBRARY_OUTPUT_PATH}/libFedTime.def
+            DESTINATION lib)
+ENDIF (MINGW)
+
+SET_TARGET_PROPERTIES(FedTime PROPERTIES VERSION 1.0.0 SOVERSION 1)
+
+# Install rules for both libRTI-NG and libFedTime
+INSTALL(TARGETS RTI FedTime
     RUNTIME DESTINATION bin
     LIBRARY DESTINATION lib
     ARCHIVE DESTINATION lib)
Index: libRTI/RTItypes.cc
===================================================================
RCS file: /sources/certi/certi/libRTI/RTItypes.cc,v
retrieving revision 1.2
diff -u -r1.2 RTItypes.cc
--- libRTI/RTItypes.cc	7 Dec 2008 20:16:16 -0000	1.2
+++ libRTI/RTItypes.cc	2 Apr 2009 19:56:33 -0000
@@ -16,7 +16,7 @@
 // License along with this program ; if not, write to the Free Software
 // Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 //
-// $Id: RTItypes.cc,v 1.2 2008/12/07 20:16:16 gotthardp Exp $
+// $Id: RTItypes.cc,v 1.2.4.1 2009/02/10 18:25:14 erk Exp $
 // ----------------------------------------------------------------------------
 
 #include "RTItypesImp.hh"
@@ -27,15 +27,6 @@
 #include <cstdlib>
 #include <cstring>
 
-using namespace certi ;
-
-namespace {
-
-static PrettyDebug D("LIBRTI", __FILE__);
-static PrettyDebug G("GENDOC",__FILE__);
-
-}
-
 // static members for HLA Exceptions
 const char *RTI::ArrayIndexOutOfBounds::_ex = "ArrayIndexOutOfBounds" ;
 const char *RTI::AsynchronousDeliveryAlreadyDisabled::_ex = "AsynchronousDeliveryAlreadyDisabled" ;
@@ -198,7 +189,7 @@
 long RTI::ValueCountExceeded::type = certi::e_ValueCountExceeded ;
 long RTI::ValueLengthExceeded::type = certi::e_ValueLengthExceeded ;
 
-static PrettyDebug PD_Exception("RTI_EXCEPTION",__FILE__);
+static PrettyDebug PD_RTIException("RTI_EXCEPTION",__FILE__);
 
 RTI::Exception::~Exception()
 {
@@ -255,7 +246,7 @@
     msg << std::endl;
     msg << std::flush;
 
-    PD_Exception[pdExcept] << msg.str().c_str();
+    PD_RTIException[pdExcept] << msg.str().c_str();
     return msg.str();
 }
 
@@ -273,4 +264,4 @@
     return os<<(*ex);
 }
 
-// $Id: RTItypes.cc,v 1.2 2008/12/07 20:16:16 gotthardp Exp $
+// $Id: RTItypes.cc,v 1.2.4.1 2009/02/10 18:25:14 erk Exp $
Index: libRTI/RTItypesImp.hh
===================================================================
RCS file: /sources/certi/certi/libRTI/RTItypesImp.hh,v
retrieving revision 3.1
diff -u -r3.1 RTItypesImp.hh
--- libRTI/RTItypesImp.hh	7 Dec 2008 20:16:17 -0000	3.1
+++ libRTI/RTItypesImp.hh	2 Apr 2009 19:56:33 -0000
@@ -19,7 +19,7 @@
 // Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
 // USA
 //
-// $Id: RTItypesImp.hh,v 3.1 2008/12/07 20:16:17 gotthardp Exp $
+// $Id: RTItypesImp.hh,v 3.1.4.2 2009/02/10 18:25:14 erk Exp $
 // ----------------------------------------------------------------------------
 
 #ifndef _RTI_TYPESIMP_HH
@@ -31,7 +31,7 @@
 namespace certi {
 
 template<class I>
-struct cast
+struct certi_cast
 {
     template<class R>
     const I& operator()(const R& imp)
@@ -44,6 +44,18 @@
             throw RTI::RTIinternalError("Incompatible object on input.");
         }
     }
+
+    template<class R>
+    I& operator()(R& imp)
+    {
+        try {
+            return dynamic_cast<I&>(imp);
+        }
+        catch (...)
+        {
+            throw RTI::RTIinternalError("Incompatible object on input.");
+        }
+    }
 };
 
 typedef std::pair<AttributeHandle, AttributeValue_t> AttributeHandleValuePair_t;
@@ -251,4 +263,4 @@
 
 #endif // _RTI_TYPESIMP_HH
 
-// $Id: RTItypesImp.hh,v 3.1 2008/12/07 20:16:17 gotthardp Exp $
+// $Id: RTItypesImp.hh,v 3.1.4.2 2009/02/10 18:25:14 erk Exp $
